module ObjCGenerator
  class CategoryGenerator

    def template_path filename
      File.join(File.expand_path("../..", File.dirname(__FILE__)), "templates/#{filename}.erb")
    end

    def generate_incipit()
      author = "Ignazioc"

      incipit_template = File.read(template_path('incipit'))
      ERB.new(incipit_template).result(binding)
    end

    def generate_category_header(class_name)
      incipit = generate_incipit()

      header_template      = File.read(template_path('category_header'))
      category_header =  ERB.new(header_template).result(binding)
      return incipit  + category_header
    end

    def generate_category_implementation(class_name)
      incipit = generate_incipit()

      template = File.read(template_path('category_implementation'))
      category_implementation =  ERB.new(template).result(binding)
      return incipit  + category_implementation
    end

  end
end
